MyGUI: MyGUI::Canvas Class Reference

MyGUI 3.4.3

Data Structures | Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions | Protected Attributes
MyGUI::Canvas Class Reference

wrapper over Texture - shows the texture. Implemented: resizing of texture (see TextureResizeMode); recovery after loosing device; More...

`#include <MyGUI_Canvas.h>`

Inheritance diagram for MyGUI::Canvas:
[legend]

## Data Structures
struct | Event

## Public Types
enum | TextureResizeMode { TRM_PT_CONST_SIZE , TRM_PT_VIEW_REQUESTED , TRM_PT_VIEW_ALL }
typedef RTTIBase | Base
typedef Canvas | RTTIBase
using | EventHandle_CanvasPtr = delegates::MultiDelegate<Canvas*>
using | EventHandle_CanvasPtrEvent = delegates::Delegate<Canvas*, Event>
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual std::string_view | getTypeName () const override
virtual bool | isType (const std::type_info &_type) const override
template<typename Type>
bool | isType () const
| Canvas ()
void | createTexture (TextureResizeMode _resizeMode, TextureUsage _usage=getDefaultTextureUsage(), PixelFormat _format=getDefaultTextureFormat())
| Creates texture.
void | createTexture (int _width, int _height, TextureResizeMode _resizeMode, TextureUsage _usage=getDefaultTextureUsage(), PixelFormat _format=getDefaultTextureFormat())
| Creates texture.
void | createTexture (const IntSize &_size, TextureResizeMode _resizeMode, TextureUsage _usage=getDefaultTextureUsage(), PixelFormat _format=getDefaultTextureFormat())
| Creates texture.
void | destroyTexture ()
| Destroys texture.
void | updateTexture ()
| Call user delegate update and removes old texture if it isn't original.
void * | lock (TextureUsage _usage=TextureUsage::Write)
| Locks hardware pixel buffer.
void | unlock ()
| Unlocks hardware pixel buffer.
bool | isLocked () const
| Checks lockness of hardware _pixel buffer.
int | getTextureRealWidth () const
| Returns real width of texture.
int | getTextureRealHeight () const
| Returns real height of texture.
IntSize | getTextureRealSize () const
| Returns real _size of texture.
int | getTextureSrcWidth () const
| Returns needed width while creating texture.
int | getTextureSrcHeight () const
| Returns needed height while creating texture.
IntSize | getTextureSrcSize () const
| Returns needed sizes while creating texture.
PixelFormat | getTextureFormat () const
| Returns needed sizes while creating texture.
const std::string & | getTextureName () const
| Returns name of the current texture.
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
TextureResizeMode | getResizeMode () const
| Returns resize mode.
void | setResizeMode (TextureResizeMode _value)
| Sets resize mode of texture.
bool | isTextureSrcSize () const
| Checks if the texture has the source (required by user) size, otherwise real texture size are bigger.
bool | isTextureCreated () const
| Returns true if the texture was created (and exists), otherwise false.
bool | isTextureManaged () const
| Returns true if we own the texture, otherwise false.
ITexture * | getTexture () const
| Reurns interface texture.
void | setTextureManaged (bool _value)
| Sets the texture managed.
void | setPosition (const IntPoint &_point) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
Public Member Functions inherited from MyGUI::Widget
template<typename Type>
bool | isType () const
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
Widget * | createWidgetT (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
template<typename T>
T * | createWidget (WidgetStyle _style, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_point)
void | setRealSize (const FloatSize &_size)
void | setRealCoord (const FloatCoord &_coord)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget.
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _alpha)
float | getAlpha () const
void | setInheritsAlpha (bool _inherits)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount () const
Widget * | getChildAt (size_t _index) const
Widget * | findWidget (std::string_view _name)
void | findWidgets (std::string_view _name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord () const
Widget * | getClientWidget ()
const Widget * | getClientWidget () const
void | detachFromWidget (std::string_view _layer={})
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, std::string_view _layer={})
void | changeWidgetSkin (std::string_view _skinName)
void | setWidgetStyle (WidgetStyle _style, std::string_view _layer={})
WidgetStyle | getWidgetStyle () const
void | setProperty (std::string_view _key, std::string_view _value)
virtual size_t | _getItemIndex (Widget *_item) const
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, std::string_view _skinName, Widget *_parent, ICroppedRectangle *_croppedParent, std::string_view _name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer () const
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
virtual void | _resetContainer (bool _update)
bool | _setWidgetState (std::string_view _state)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type>
bool | isType () const
template<typename Type>
Type * | castType (bool _throw=true)
template<typename Type>
const Type * | castType (bool _throw=true) const
virtual | ~IObject ()=default
Public Member Functions inherited from MyGUI::ICroppedRectangle
virtual | ~ICroppedRectangle ()=default
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
virtual | ~UserData ()=default
void | setUserString (std::string_view _key, std::string_view _value)
std::string_view | getUserString (std::string_view _key) const
const MapString & | getUserStrings () const
bool | clearUserString (std::string_view _key)
bool | isUserString (std::string_view _key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType>
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType>
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
virtual | ~WidgetInput ()=default
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (std::string_view _value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()=default
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
ISubWidgetText * | getSubWidgetText () const
ISubWidgetRect * | getSubWidgetMain () const
void | _setTextureName (std::string_view _texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
void | attachItemToNode (ILayer *_layer, ILayerNode *_node) override
void | detachFromLayer () override
void | upLayerItem () override
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()=default
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::ITextureInvalidateListener
virtual | ~ITextureInvalidateListener ()=default

## Static Public Member Functions
static std::string_view | getClassTypeName ()
static TextureUsage | getDefaultTextureUsage ()
| Returns default GUI texture usage.
static PixelFormat | getDefaultTextureFormat ()
| Returns default GUI texture format.
Static Public Member Functions inherited from MyGUI::Widget
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static std::string_view | getClassTypeName ()

## Data Fields
EventHandle_CanvasPtr | eventPreTextureChanges
EventHandle_CanvasPtrEvent | requestUpdateCanvas
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
EventHandle_WidgetVoid | eventWidgetDestroyed
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions
void | shutdownOverride () override
void | initialiseOverride () override
void | _destroyTexture (bool _sendEvent)
| Destroys texture.
void | validate (int &_width, int &_height, TextureUsage &_usage, PixelFormat &_format) const
| Update entered parameters according to current texture resize mode(size) and restore (if can) parameters of usage and format from texture.
void | createExactTexture (int _width, int _height, TextureUsage _usage, PixelFormat _format)
| Creates the texture itself.
bool | checkCreate (int _width, int _height) const
| Checks if we need to create a texture with such sizes.
void | resize (const IntSize &_size)
| Calls when resize widget.
void | correctUV ()
| Correct texture uv-coordinates.
void | frameAdvise (bool _advise)
| For updating once per frame.
void | frameEntered (float _time)
| For updating once per frame.
void | textureInvalidate (ITexture *_texture) override
void | _setUVSet (const FloatRect &_rect)
Protected Member Functions inherited from MyGUI::Widget
| ~Widget () override=default
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer, std::string_view _name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point) const
virtual void | baseUpdateEnable ()
ILayerItem * | getLayerItemByPoint (int _left, int _top) const override
const IntCoord & | getLayerItemCoord () const override
template<typename T>
void | assignWidget (T *&_widget, std::string_view _name)
VectorWidgetPtr | getSkinWidgetsByName (std::string_view _name) const
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Widget * | _getClientWidget ()
| If there is client widget return it, otherwise return this.
const Widget * | _getClientWidget () const
virtual void | setPropertyOverride (std::string_view _key, std::string_view _value)
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (std::string_view _state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_item, bool _deep)
void | detachFromLayerItemNode (bool _deep)

## Protected Attributes
ITexture * | mTexture {nullptr}
| Current texture.
IntSize | mReqTexSize
| Requested bu user sizes.
std::string | mGenTexName
| Generated texture name.
TextureResizeMode | mTexResizeMode {TRM_PT_CONST_SIZE}
| Texture resize mode.
uint8 * | mTexData {nullptr}
| Saved pointer from last calling lock.
bool | mTexManaged {true}
| true if we own the texture (can delete it or replace by another instance), otherwise false
bool | mFrameAdvise {false}
| For updating once per frame. True state means updating before next frame starts.
bool | mInvalidateData {false}
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin {false}
ICroppedRectangle * | mCroppedParent {nullptr}

## Detailed Description

wrapper over Texture - shows the texture. Implemented: resizing of texture (see TextureResizeMode); recovery after loosing device;

Definition at line 21 of file MyGUI_Canvas.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::Canvas::Base

Definition at line 23 of file MyGUI_Canvas.h.

## ◆ EventHandle_CanvasPtr

using MyGUI::Canvas::EventHandle_CanvasPtr = delegates::MultiDelegate<Canvas*>

Definition at line 44 of file MyGUI_Canvas.h.

## ◆ EventHandle_CanvasPtrEvent

using MyGUI::Canvas::EventHandle_CanvasPtrEvent = delegates::Delegate<Canvas*, Event>

Definition at line 45 of file MyGUI_Canvas.h.

## ◆ RTTIBase

typedef Canvas MyGUI::Canvas::RTTIBase

Definition at line 23 of file MyGUI_Canvas.h.

## Member Enumeration Documentation

## ◆ TextureResizeMode

enum MyGUI::Canvas::TextureResizeMode

Available resize and view modes of texture

Remarks
  PT - Power of Two (size)

Enumerator
TRM_PT_CONST_SIZE | Mode when the texture has constant size and stretching on all widget. Remarks The size specified at creation of the texture increases to nearest power of two and doesn't change any more. Texture is always stretched on all widget.
TRM_PT_VIEW_REQUESTED | Mode when texture pixels look as is. Remarks The texture size is always more or equal than the widget size and is equal to a power of two. Note The size specified at creation of the texture is ignored. The texture is automatically recreated if the size of the widget becomes bigger.
TRM_PT_VIEW_ALL | Mode when the texture stretched on all widget and automatically changes the size for nice look. Remarks The mode same as TRM_PT_VIEW_REQUESTED, but the texture is scaled till the size of the widget. Note The size specified at creation of the texture is ignored. The texture is automatically recreated if the size of the widget becomes bigger.

Definition at line 51 of file MyGUI_Canvas.h.

## Constructor & Destructor Documentation

## ◆ Canvas()

MyGUI::Canvas::Canvas | ( |  | ) |

Definition at line 17 of file MyGUI_Canvas.cpp.

## Member Function Documentation

## ◆ _destroyTexture()

void MyGUI::Canvas::_destroyTexture | ( | bool | _sendEvent | ) |
| protected

Destroys texture.

Definition at line 165 of file MyGUI_Canvas.cpp.

## ◆ _setUVSet()

void MyGUI::Canvas::_setUVSet | ( | const FloatRect & | _rect | ) |
| protected

Definition at line 269 of file MyGUI_Canvas.cpp.

## ◆ checkCreate()

bool MyGUI::Canvas::checkCreate | ( | int | _width,
|  | int | _height ) const
| protected

Checks if we need to create a texture with such sizes.

Definition at line 120 of file MyGUI_Canvas.cpp.

## ◆ correctUV()

void MyGUI::Canvas::correctUV | ( |  | ) |
| protected

Correct texture uv-coordinates.

Definition at line 179 of file MyGUI_Canvas.cpp.

## ◆ createExactTexture()

void MyGUI::Canvas::createExactTexture | ( | int | _width,
|  | int | _height,
|  | TextureUsage | _usage,
|  | PixelFormat | _format )
| protected

Creates the texture itself.

Definition at line 42 of file MyGUI_Canvas.cpp.

## ◆ createTexture() [1/3]

void MyGUI::Canvas::createTexture | ( | const IntSize & | _size,
|  | TextureResizeMode | _resizeMode,
|  | TextureUsage | _usage = getDefaultTextureUsage(),
|  | PixelFormat | _format = getDefaultTextureFormat() )

Creates texture.

Definition at line 30 of file MyGUI_Canvas.cpp.

## ◆ createTexture() [2/3]

void MyGUI::Canvas::createTexture | ( | int | _width,
|  | int | _height,
|  | TextureResizeMode | _resizeMode,
|  | TextureUsage | _usage = getDefaultTextureUsage(),
|  | PixelFormat | _format = getDefaultTextureFormat() )

Creates texture.

Definition at line 70 of file MyGUI_Canvas.cpp.

## ◆ createTexture() [3/3]

void MyGUI::Canvas::createTexture | ( | TextureResizeMode | _resizeMode,
|  | TextureUsage | _usage = getDefaultTextureUsage(),
|  | PixelFormat | _format = getDefaultTextureFormat() )

Creates texture.

Definition at line 22 of file MyGUI_Canvas.cpp.

## ◆ destroyTexture()

void MyGUI::Canvas::destroyTexture | ( |  | ) |

Destroys texture.

Definition at line 150 of file MyGUI_Canvas.cpp.

## ◆ frameAdvise()

void MyGUI::Canvas::frameAdvise | ( | bool | _advise | ) |
| protected

For updating once per frame.

Definition at line 215 of file MyGUI_Canvas.cpp.

## ◆ frameEntered()

void MyGUI::Canvas::frameEntered | ( | float | _time | ) |
| protected

For updating once per frame.

Definition at line 235 of file MyGUI_Canvas.cpp.

## ◆ getClassTypeName()

std::string_view MyGUI::Canvas::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 23 of file MyGUI_Canvas.h.

## ◆ getDefaultTextureFormat()

PixelFormat MyGUI::Canvas::getDefaultTextureFormat | ( |  | ) |
| static

Returns default GUI texture format.

Definition at line 355 of file MyGUI_Canvas.cpp.

## ◆ getDefaultTextureUsage()

TextureUsage MyGUI::Canvas::getDefaultTextureUsage | ( |  | ) |
| static

Returns default GUI texture usage.

Definition at line 350 of file MyGUI_Canvas.cpp.

## ◆ getResizeMode()

Canvas::TextureResizeMode MyGUI::Canvas::getResizeMode | ( |  | ) | const

Returns resize mode.

Definition at line 320 of file MyGUI_Canvas.cpp.

## ◆ getTexture()

ITexture * MyGUI::Canvas::getTexture | ( |  | ) | const

Reurns interface texture.

Definition at line 340 of file MyGUI_Canvas.cpp.

## ◆ getTextureFormat()

PixelFormat MyGUI::Canvas::getTextureFormat | ( |  | ) | const

Returns needed sizes while creating texture.

Definition at line 310 of file MyGUI_Canvas.cpp.

## ◆ getTextureName()

const std::string & MyGUI::Canvas::getTextureName | ( |  | ) | const

Returns name of the current texture.

Definition at line 315 of file MyGUI_Canvas.cpp.

## ◆ getTextureRealHeight()

int MyGUI::Canvas::getTextureRealHeight | ( |  | ) | const

Returns real height of texture.

Definition at line 285 of file MyGUI_Canvas.cpp.

## ◆ getTextureRealSize()

IntSize MyGUI::Canvas::getTextureRealSize | ( |  | ) | const

Returns real _size of texture.

Definition at line 290 of file MyGUI_Canvas.cpp.

## ◆ getTextureRealWidth()

int MyGUI::Canvas::getTextureRealWidth | ( |  | ) | const

Returns real width of texture.

Definition at line 280 of file MyGUI_Canvas.cpp.

## ◆ getTextureSrcHeight()

int MyGUI::Canvas::getTextureSrcHeight | ( |  | ) | const

Returns needed height while creating texture.

Definition at line 300 of file MyGUI_Canvas.cpp.

## ◆ getTextureSrcSize()

IntSize MyGUI::Canvas::getTextureSrcSize | ( |  | ) | const

Returns needed sizes while creating texture.

Definition at line 305 of file MyGUI_Canvas.cpp.

## ◆ getTextureSrcWidth()

int MyGUI::Canvas::getTextureSrcWidth | ( |  | ) | const

Returns needed width while creating texture.

Definition at line 295 of file MyGUI_Canvas.cpp.

## ◆ getTypeName()

virtual std::string_view MyGUI::Canvas::getTypeName | ( |  | ) | const
| inlineoverridevirtual

Get type name as string

Reimplemented from MyGUI::Widget.

Definition at line 23 of file MyGUI_Canvas.h.

## ◆ initialiseOverride()

void MyGUI::Canvas::initialiseOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 161 of file MyGUI_Canvas.cpp.

## ◆ isLocked()

bool MyGUI::Canvas::isLocked | ( |  | ) | const

Checks lockness of hardware _pixel buffer.

Definition at line 275 of file MyGUI_Canvas.cpp.

## ◆ isTextureCreated()

bool MyGUI::Canvas::isTextureCreated | ( |  | ) | const

Returns true if the texture was created (and exists), otherwise false.

Definition at line 330 of file MyGUI_Canvas.cpp.

## ◆ isTextureManaged()

bool MyGUI::Canvas::isTextureManaged | ( |  | ) | const

Returns true if we own the texture, otherwise false.

See also
  mManaged

Definition at line 335 of file MyGUI_Canvas.cpp.

## ◆ isTextureSrcSize()

bool MyGUI::Canvas::isTextureSrcSize | ( |  | ) | const

Checks if the texture has the source (required by user) size, otherwise real texture size are bigger.

Definition at line 210 of file MyGUI_Canvas.cpp.

## ◆ isType() [1/2]

template<typename Type>

bool MyGUI::Canvas::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 23 of file MyGUI_Canvas.h.

## ◆ isType() [2/2]

virtual bool MyGUI::Canvas::isType | ( | const std::type_info & | _type | ) | const
| inlineoverridevirtual

Compare with selected type

Reimplemented from MyGUI::Widget.

Definition at line 23 of file MyGUI_Canvas.h.

## ◆ lock()

void * MyGUI::Canvas::lock | ( | TextureUsage | _usage = TextureUsage::Write | ) |

Locks hardware pixel buffer.

Definition at line 196 of file MyGUI_Canvas.cpp.

## ◆ resize()

void MyGUI::Canvas::resize | ( | const IntSize & | _size | ) |
| protected

Calls when resize widget.

Definition at line 60 of file MyGUI_Canvas.cpp.

## ◆ setCoord() [1/2]

void MyGUI::Canvas::setCoord | ( | const IntCoord & | _coord | ) |
| overridevirtual

Set widget position and size

Reimplemented from MyGUI::ICroppedRectangle.

Definition at line 107 of file MyGUI_Canvas.cpp.

## ◆ setCoord() [2/2]

void MyGUI::Widget::setCoord | ( | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height )

See Widget::setCoord(const IntCoord& _coord)

Definition at line 179 of file MyGUI_Widget.cpp.

## ◆ setPosition() [1/2]

void MyGUI::Widget::setPosition | ( | const IntPoint & | _point | ) |
| overridevirtual

Set widget position (position of left top corner)

Reimplemented from MyGUI::ICroppedRectangle.

Definition at line 168 of file MyGUI_Widget.cpp.

## ◆ setPosition() [2/2]

void MyGUI::Widget::setPosition | ( | int | _left,
|  | int | _top )

See Widget::setPosition(const IntPoint& _pos)

Definition at line 175 of file MyGUI_Widget.cpp.

## ◆ setResizeMode()

void MyGUI::Canvas::setResizeMode | ( | TextureResizeMode | _value | ) |

Sets resize mode of texture.

See also
  TextureResizeMode

Definition at line 325 of file MyGUI_Canvas.cpp.

## ◆ setSize() [1/2]

void MyGUI::Canvas::setSize | ( | const IntSize & | _size | ) |
| overridevirtual

Set widget size

Reimplemented from MyGUI::ICroppedRectangle.

Definition at line 100 of file MyGUI_Canvas.cpp.

## ◆ setSize() [2/2]

void MyGUI::Widget::setSize | ( | int | _width,
|  | int | _height )

See Widget::setSize(const IntSize& _size)

Definition at line 177 of file MyGUI_Widget.cpp.

## ◆ setTextureManaged()

void MyGUI::Canvas::setTextureManaged | ( | bool | _value | ) |

Sets the texture managed.

Remarks
  Be careful with assigning managed status to texture, which wasn't created in Canvas!

See also
  mManaged

Definition at line 345 of file MyGUI_Canvas.cpp.

## ◆ shutdownOverride()

void MyGUI::Canvas::shutdownOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 155 of file MyGUI_Canvas.cpp.

## ◆ textureInvalidate()

void MyGUI::Canvas::textureInvalidate | ( | ITexture * | _texture | ) |
| overrideprotectedvirtual

Implements MyGUI::ITextureInvalidateListener.

Definition at line 264 of file MyGUI_Canvas.cpp.

## ◆ unlock()

void MyGUI::Canvas::unlock | ( |  | ) |

Unlocks hardware pixel buffer.

Definition at line 205 of file MyGUI_Canvas.cpp.

## ◆ updateTexture()

void MyGUI::Canvas::updateTexture | ( |  | ) |

Call user delegate update and removes old texture if it isn't original.

Definition at line 114 of file MyGUI_Canvas.cpp.

## ◆ validate()

void MyGUI::Canvas::validate | ( | int & | _width,
|  | int & | _height,
|  | TextureUsage & | _usage,
|  | PixelFormat & | _format ) const
| protected

Update entered parameters according to current texture resize mode(size) and restore (if can) parameters of usage and format from texture.

Definition at line 131 of file MyGUI_Canvas.cpp.

## Field Documentation

## ◆ eventPreTextureChanges

EventHandle_CanvasPtr MyGUI::Canvas::eventPreTextureChanges

Event : Notify user texture instance will be changed

See also
  requestUpdateCanvas.
  signature : void method(MyGUI::Canvas* _canvas)

Parameters

  _canvas,which | will be updated

Definition at line 191 of file MyGUI_Canvas.h.

## ◆ mFrameAdvise

bool MyGUI::Canvas::mFrameAdvise {false}
| protected

For updating once per frame. True state means updating before next frame starts.

Definition at line 252 of file MyGUI_Canvas.h.

## ◆ mGenTexName

std::string MyGUI::Canvas::mGenTexName
| protected

Generated texture name.

Definition at line 240 of file MyGUI_Canvas.h.

## ◆ mInvalidateData

bool MyGUI::Canvas::mInvalidateData {false}
| protected

Definition at line 254 of file MyGUI_Canvas.h.

## ◆ mReqTexSize

IntSize MyGUI::Canvas::mReqTexSize
| protected

Requested bu user sizes.

Definition at line 237 of file MyGUI_Canvas.h.

## ◆ mTexData

uint8* MyGUI::Canvas::mTexData {nullptr}
| protected

Saved pointer from last calling lock.

See also
  lock

Definition at line 246 of file MyGUI_Canvas.h.

## ◆ mTexManaged

bool MyGUI::Canvas::mTexManaged {true}
| protected

true if we own the texture (can delete it or replace by another instance), otherwise false

Definition at line 249 of file MyGUI_Canvas.h.

## ◆ mTexResizeMode

TextureResizeMode MyGUI::Canvas::mTexResizeMode {TRM_PT_CONST_SIZE}
| protected

Texture resize mode.

See also
  TextureResizeMode

Definition at line 243 of file MyGUI_Canvas.h.

## ◆ mTexture

ITexture* MyGUI::Canvas::mTexture {nullptr}
| protected

Current texture.

Definition at line 234 of file MyGUI_Canvas.h.

## ◆ requestUpdateCanvas

EventHandle_CanvasPtrEvent MyGUI::Canvas::requestUpdateCanvas

Event : Texture instance was changed (May be caused by resizing texture or lossing device). User have to update all references to new instance of texture.
signature : void method(MyGUI::Canvas* _canvas, MyGUI::Canvas::Event _event)

Parameters

  _canvas,which | needs to update
  _event |

Definition at line 198 of file MyGUI_Canvas.h.

The documentation for this class was generated from the following files:

- MyGUI_Canvas.h
- MyGUI_Canvas.cpp